#ifndef __EDIO_H
#define __EDIO_H

typedef enum {
  EDIO_PWM=1, EDIO_QUADRATURE=2, EDIO_EDGECOUNT=3, EDIO_GLITCHED=4
} EDIOType;

typedef struct EDIO EDIO;
typedef struct EDIOAPI EDIOAPI;

struct EDIOAPI {
  void *FUNC(Init)(void *me);
  void FUNC(Fini)(void *me);
  int FUNC(Lock)(void *me,unsigned num,int flags);
  int FUNC(Unlock)(void *me,unsigned num,int flags);
  int FUNC(Preempt)(void *me);
  int* FUNC(QueryFunction)(void *me,EDIOType type);
  int FUNC(PWM)(void *me,int num,int periodHigh,int periodLow);
  int FUNC(QuadratureCount)(void *me,int num);
  int FUNC(EdgeCount)(void *me,int num);
  int FUNC(Glitched)(void *me,int num);
};

struct EDIO {
  EDIOAPI;
  int InitStatus;
};

enum {
  NetEDIO_Lock=0,
  NetEDIO_Unlock=1,
  NetEDIO_Preempt=2,
  NetEDIO_QueryFunction=3,
  NetEDIO_PWM=4,
  NetEDIO_QuadratureCount=5,
  NetEDIO_EdgeCount=6,
  NetEDIO_Glitched=7
};
#define EDIO_APICount (1+NetEDIO_Glitched)

#endif
// Author: Michael Schmidt (michael@embeddedARM.com)
// Copyright (c) 2012, Technologic Systems, All Rights Reserved
// Refer to the COPYRIGHT file provided with this project for licensing terms.

